## mingw-w64-texstudio-4.8.2-1.src.tar.zst

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1.0)

project(TeXstudio VERSION 4.8.2 LANGUAGES C CXX)
SET(CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR}/cmake ${CMAKE_MODULE_PATH})
set(CMAKE_DEBUG_POSTFIX "d")
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_AUTOUIC ON)
set(CMAKE_INCLUDE_CURRENT_DIR ON)
if(APPLE)
set(CMAKE_CXX_STANDARD 20)
else()
set(CMAKE_CXX_STANDARD 17)
endif()


list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")

find_package(GitInfo)
if(GIT_FOUND AND EXISTS "${PROJECT_SOURCE_DIR}/.git")
	git_wc_info(${PROJECT_SOURCE_DIR} VARPREFIX)
	add_definitions(-DTEXSTUDIO_VERSION="${VARPREFIX_WC_LATEST_TAG_LONG}")
	message(STATUS "The current git hash is ${VARPREFIX_WC_REVISION_HASH}")
	message(STATUS "The current git describe is ${VARPREFIX_WC_LATEST_TAG_LONG}")
else()
	add_definitions(-DTEXSTUDIO_VERSION="${CMAKE_PROJECT_VERSION}")
	message(STATUS "No git present.")
    unset(GIT_FOUND)
	set(VARPREFIX_WC_LATEST_TAG_LONG "${CMAKE_PROJECT_VERSION}+0+0")
endif()
include(cmake/project_version.cmake)

if(MSVC)
	set(ADDITIONAL_DEFINITIONS ${ADDITIONAL_DEFINITIONS} -D_CRT_SECURE_NO_WARNINGS -D_UNICODE -DUNICODE)
	add_compile_options(/wd4267 /wd4244)
	add_compile_options($<$<CXX_COMPILER_ID:MSVC>:/MP>)
else()
	add_compile_options(-Wno-deprecated-declarations)
endif()

if(WIN32 AND NOT MSVC)
        add_compile_options($<$<COMPILE_LANGUAGE:CXX>:-fpermissive>)
        add_compile_options(-Wa,-mbig-obj)
endif()

find_package(QT NAMES Qt6 Qt5 COMPONENTS Widgets LinguistTools REQUIRED)
find_package(Qt${QT_VERSION_MAJOR} COMPONENTS Core Network Xml Concurrent Widgets UiTools REQUIRED)
find_package(Qt${QT_VERSION_MAJOR} COMPONENTS PrintSupport Svg Qml REQUIRED)
if(${QT_VERSION_MAJOR} GREATER_EQUAL 6)
	find_package(Qt${QT_VERSION_MAJOR} COMPONENTS Core5Compat REQUIRED)
	find_package(Qt${QT_VERSION_MAJOR} COMPONENTS LinguistTools QUIET)
endif()

message(STATUS "building for Qt ${QT_VERSION_MAJOR}")

# Source
add_subdirectory(src)

# qtsingleapplication
add_subdirectory(src/qtsingleapplication)

# main
set(RESOURCE_FILES 
	texstudio.qrc
	symbols.qrc
	completion.qrc
	images.qrc
)
if(APPLE)
    file(GLOB manual
        utilities/manual/build/html/*.html
    )
    set(manual ${manual} utilities/manual/build/html/searchindex.js)
    file(GLOB images
        utilities/manual/build/html/_images/*.webp
    )
    file(GLOB static
        utilities/manual/build/html/_static/*
    )
    file(GLOB static_scripts
        utilities/manual/build/html/_static/scripts/*
    )
    file(GLOB static_styles
        utilities/manual/build/html/_static/styles/*
    )
    file(GLOB design_static
        utilities/manual/build/html/_sphinx_design_static/*
    )
    file(GLOB_RECURSE templates
       templates/*
    )
    file(GLOB_RECURSE translation
       translation/*.qm
    )
    file(GLOB_RECURSE dictionaries
       utilities/dictionaries/*
    )

    set(OSX_FILES
        texstudio.icns
        utilities/latex2e.html
        utilities/latex2e.css
		utilities/list.png
		utilities/manual/source/CHANGELOG.md
        ${templates}
        ${dictionaries}
        ${translation}
    )
else()
    set(OSX_FILES "")
endif()

set(TRANSLATION_FILES
	translation/texstudio_en.ts
)
if(${QT_VERSION_MAJOR} GREATER_EQUAL 6 AND CMAKE_BUILD_TYPE STREQUAL "Debug")
	if(${QT_VERSION_MINOR} LESS_EQUAL 6)
		message(STATUS "Generate translation source option.")
		qt6_add_lupdate(texstudio TS_FILES ${TRANSLATION_FILES})
	endif()
	if(${QT_VERSION_MINOR} GREATER_EQUAL 7)
                message(STATUS "Generate translation source option. (>= Qt6.7)")
                qt6_add_translations(texstudio TS_FILES ${TRANSLATION_FILES})
	endif()
endif()

if(WIN32)
	set(SOURCE_FILES ${SOURCE_FILES} win.rc)
endif()
if(UNIX AND NOT APPLE AND NOT HAIKU)
	add_subdirectory(src/xkb)
endif()

# Hunspell
find_package(Hunspell QUIET)
if(Hunspell_FOUND)
	message(STATUS "Using system Hunspell")
	set(HUNSPELL_SOURCE_LINK 0)
	get_filename_component(HUNSPELL_LIB_NAME ${HUNSPELL_LIBRARIES} NAME)
	string(FIND ${HUNSPELL_LIB_NAME} "static" HUNSPELL_IS_STATIC_POS)
	if(${HUNSPELL_IS_STATIC_POS} GREATER 0)
		set(HUNSPELL_SOURCE_LINK 1)
	endif()
	if(${HUNSPELL_SOURCE_LINK} GREATER 0)
		option(HUNSPELL_IS_STATIC "Hunspell is a static library" ON)
	else()
		option(HUNSPELL_IS_STATIC "Hunspell is a static library" OFF)
	endif()
else()
	message(STATUS "Using internal Hunspell")
	add_subdirectory(src/hunspell)
	set(HUNSPELL_SOURCE_LINK 2)
	set(HUNSPELL_IS_STATIC ON)
endif()
if(${HUNSPELL_IS_STATIC})
	set(ADDITIONAL_DEFINITIONS ${ADDITIONAL_DEFINITIONS} -DHUNSPELL_STATIC)
endif()

# qcodeedit
add_subdirectory(src/qcodeedit)

# debughelper
add_subdirectory(src/debug)

# latexparser
add_subdirectory(src/latexparser)

# symbolpanel
add_subdirectory(src/symbolpanel)

#qtermwidget
if(${QT_VERSION_MAJOR} LESS_EQUAL 5)
    find_package(QTermWidget QUIET)
    if(QTermWidget_FOUND)
        message(STATUS "Using QTermWidget5")
        set(ADDITIONAL_DEFINITIONS ${ADDITIONAL_DEFINITIONS} -DINTERNAL_TERMINAL)
    endif()
endif()

# QuaZIP
find_package(QuaZip-Qt${QT_VERSION_MAJOR} QUIET)
if(QuaZip-Qt${QT_VERSION_MAJOR}_FOUND)
	message(STATUS "quazip 1.x found")
else()
	find_package(QuaZip QUIET)
	if(QUAZIP_FOUND)
		message(STATUS "Using system QuaZIP")
		set(QUAZIP_SOURCE_LINK 0)
		get_filename_component(QUAZIP_LIB_NAME ${QUAZIP_LIBRARIES} NAME)
		string(FIND ${QUAZIP_LIB_NAME} "static" QUAZIP_IS_STATIC_POS)
		if(${QUAZIP_IS_STATIC_POS} GREATER 0)
			set(QUAZIP_SOURCE_LINK 1)
		endif()
		if(${QUAZIP_SOURCE_LINK} GREATER 0)
			option(QUAZIP_IS_STATIC "QuaZIP is a static library" ON)
		else()
			option(QUAZIP_IS_STATIC "QuaZIP is a static library" OFF)
		endif()
	else()
                message(STATUS "Using internal QuaZIP and internal zlib")
                if(WIN32)
                    set(ZLIB_BUILD_EXAMPLES OFF)
                    set(SKIP_INSTALL_LIBRARIES ON)
                    add_subdirectory(src/zlib-1.3.1)
                    set(ZLIB_INCLUDE_DIR ${CMAKE_CURRENT_BINARY_DIR}/src/zlib-1.3.1)
                    if(CMAKE_BUILD_TYPE STREQUAL "Debug")
                        set(ZLIB_LIBRARY ${CMAKE_CURRENT_BINARY_DIR}/src/zlib-1.3.1/libzlibd.dll)
                    else()
                        set(ZLIB_LIBRARY ${CMAKE_CURRENT_BINARY_DIR}/src/zlib-1.3.1/libzlib.dll)
                    endif()
                endif()
		set(BUILD_SHARED_LIBS OFF)
  		set(QUAZIP_INSTALL OFF)
                set(QUAZIP_USE_QT_ZLIB OFF)
                set(QUAZIP_ENABLE_TESTS OFF)
		set(QUAZIP_BZIP2 OFF)
		set(QUAZIP_IS_STATIC ON)
		set(QUAZIP_SOURCE_LINK 2)
		add_subdirectory(src/quazip)
	endif()
	if(${QUAZIP_IS_STATIC})
		set(ADDITIONAL_DEFINITIONS ${ADDITIONAL_DEFINITIONS} -DQUAZIP_STATIC)
	endif()
endif()

# Options
if(NOT MSVC)
	option(TEXSTUDIO_ENABLE_CRASH_HANDLER "Enable/Disable internal crash handler" ON)
	if(NOT ${TEXSTUDIO_ENABLE_CRASH_HANDLER})
		message(STATUS "Internal crash handler disabled as you wish.")
		set(ADDITIONAL_DEFINITIONS ${ADDITIONAL_DEFINITIONS} -DNO_CRASH_HANDLER)
	endif()
else()
	set(ADDITIONAL_DEFINITIONS ${ADDITIONAL_DEFINITIONS} -DNO_CRASH_HANDLER)
endif()

option(TEXSTUDIO_BUILD_ADWAITA "Enable/Disable internal adwaita-qt style" ON)
if(TEXSTUDIO_BUILD_ADWAITA)
    find_package(Qt${QT_VERSION_MAJOR}DBus REQUIRED)
    set(ADDITIONAL_DEFINITIONS ${ADDITIONAL_DEFINITIONS} -DADWAITA)
    message(STATUS "integrate adwaita style")
endif()
add_subdirectory(src/adwaita-qt)

option(TEXSTUDIO_ENABLE_TESTS "Enable/Disable internal tests" OFF)
if(${TEXSTUDIO_ENABLE_TESTS})
	message(STATUS "tests enabled.")
	find_package(Qt${QT_VERSION_MAJOR} COMPONENTS Test REQUIRED)
        set(ADDITIONAL_DEFINITIONS ${ADDITIONAL_DEFINITIONS} -DTESTDATADIR="${CMAKE_CURRENT_SOURCE_DIR}/src/tests/testdata")
	set(HEADER_FILES ${HEADER_FILES}
		src/tests/buildmanager_t.h
		src/tests/codesnippet_t.h
		src/tests/encoding_t.h
		src/tests/execprogram_t.h
		src/tests/git_t.h
		src/tests/help_t.h
		src/tests/latexcompleter_t.h
		src/tests/latexdocument_t.h
		src/tests/latexeditorview_bm.h
		src/tests/latexeditorview_t.h
		src/tests/latexoutputfilter_t.h
		src/tests/latexparser_t.h
		src/tests/latexparsing_t.h
		src/tests/latexstyleparser_t.h
		src/tests/qcetestutil.h
		src/tests/qdocumentcursor_t.h
		src/tests/qdocumentline_t.h
		src/tests/qdocumentsearch_t.h
		src/tests/qeditor_t.h
		src/tests/qsearchreplacepanel_t.h
		src/tests/scriptengine_t.h
		src/tests/smallUsefulFunctions_t.h
		src/tests/structureview_t.h
		src/tests/syntaxcheck_t.h
		src/tests/tablemanipulation_t.h
		src/tests/testmanager.h
		src/tests/testutil.h
                src/tests/texstudio_t.h
		src/tests/updatechecker_t.h
		src/tests/usermacro_t.h
		src/tests/utilsui_t.h
		src/tests/utilsversion_t.h
	)
	set(SOURCE_FILES ${SOURCE_FILES}
		src/tests/codesnippet_t.cpp
		src/tests/encoding_t.cpp
		src/tests/execprogram_t.cpp
		src/tests/git_t.cpp
		src/tests/latexcompleter_t.cpp
		src/tests/latexdocument_t.cpp
		src/tests/latexeditorview_bm.cpp
		src/tests/latexeditorview_t.cpp
		src/tests/latexoutputfilter_t.cpp
		src/tests/latexparser_t.cpp
		src/tests/latexparsing_t.cpp
		src/tests/latexstyleparser_t.cpp
		src/tests/qcetestutil.cpp
		src/tests/qdocumentcursor_t.cpp
		src/tests/qdocumentline_t.cpp
		src/tests/qdocumentsearch_t.cpp
		src/tests/qeditor_t.cpp
		src/tests/qsearchreplacepanel_t.cpp
		src/tests/scriptengine_t.cpp
		src/tests/smallUsefulFunctions_t.cpp
		src/tests/structureview_t.cpp
		src/tests/syntaxcheck_t.cpp
		src/tests/tablemanipulation_t.cpp
		src/tests/testmanager.cpp
		src/tests/testutil.cpp
                src/tests/texstudio_t.cpp
		src/tests/usermacro_t.cpp
	)
else()
	message(STATUS "tests disabled.")
	set(ADDITIONAL_DEFINITIONS ${ADDITIONAL_DEFINITIONS} -DNO_TESTS)
endif()

option(TEXSTUDIO_ENABLE_MEDIAPLAYER "Enable/Disable the video player in pdf files" OFF)
if(${TEXSTUDIO_ENABLE_MEDIAPLAYER})
	message(STATUS "the video player in pdf files is enabled.")
	find_package(Qt${QT_VERSION_MAJOR} COMPONENTS Multimedia MultimediaWidgets REQUIRED)
	set(ADDITIONAL_DEFINITIONS ${ADDITIONAL_DEFINITIONS} -DMEDIAPLAYER)
else()
	message(STATUS "the video player in pdf files is disabled.")
endif()

option(TEXSTUDIO_ENABLE_DEBUG_LOGGER "Enable/Disable debug logger" OFF)
if(${TEXSTUDIO_ENABLE_DEBUG_LOGGER})
	message(STATUS "Debug logger is built.")
	set(ADDITIONAL_DEFINITIONS ${ADDITIONAL_DEFINITIONS} -DDEBUG_LOGGER)
endif()

# poppler

find_package(PkgConfig)
pkg_check_modules(POPPLER QUIET IMPORTED_TARGET poppler poppler-cpp poppler-qt${QT_VERSION_MAJOR})
if(POPPLER_FOUND)
    message(STATUS "Build internal pdf previewer.")
else()
    message(STATUS "Poppler not found, internal pdf previewer disabled.")
    set(ADDITIONAL_DEFINITIONS ${ADDITIONAL_DEFINITIONS} -DNO_POPPLER_PREVIEW)
    if(WIN32)
        set(ADDITIONAL_DEFINITIONS ${ADDITIONAL_DEFINITIONS} -D_WIN32)
    endif()
endif()
add_subdirectory(src/pdfviewer)

# Build texstudio application
add_executable(texstudio ${SOURCE_FILES} ${HEADER_FILES} ${RESOURCE_FILES} ${FORM_FILES} ${OSX_FILES} ${manual} ${images} ${static} ${static_scripts} ${static_styles} ${design_static}
)
target_link_libraries(texstudio PRIVATE
    Qt${QT_VERSION_MAJOR}::Core
    Qt${QT_VERSION_MAJOR}::Gui
    Qt${QT_VERSION_MAJOR}::Widgets
    Qt${QT_VERSION_MAJOR}::PrintSupport
    Qt${QT_VERSION_MAJOR}::Svg
    Qt${QT_VERSION_MAJOR}::Network
    Qt${QT_VERSION_MAJOR}::Xml
    Qt${QT_VERSION_MAJOR}::Qml
    Qt${QT_VERSION_MAJOR}::Concurrent
    Qt${QT_VERSION_MAJOR}::UiTools
)
if(NOT MSVC AND CMAKE_VERSION VERSION_GREATER_EQUAL "3.16.0")
    target_precompile_headers(texstudio PUBLIC src/mostQtHeaders.h)
endif()
if(${QT_VERSION_MAJOR} GREATER_EQUAL 6)
    target_link_libraries(texstudio PRIVATE Qt${QT_VERSION_MAJOR}::Core5Compat)
endif()
if(TEXSTUDIO_BUILD_ADWAITA)
    target_link_libraries(texstudio PRIVATE Qt${QT_VERSION_MAJOR}::DBus)
endif()

set_source_files_properties(${OSX_FILES} PROPERTIES MACOSX_PACKAGE_LOCATION "Resources")

=== utilities/poppler-data/Makefile ===
PACKAGE    = poppler-data
VERSION    = 0.4.6
distdir    = $(PACKAGE)-$(VERSION)
prefix     = /usr/local
datadir    = $(prefix)/share
pkgdatadir = $(datadir)/poppler

all :

install :
	install -d -m 0755 $(DESTDIR)$(pkgdatadir)/cidToUnicode
	install -m 0644 $(cid-to-unicode-files) $(DESTDIR)$(pkgdatadir)/cidToUnicode
	install -d -m 0755 $(DESTDIR)$(pkgdatadir)/nameToUnicode
	install -m 0644 $(name-to-unicode-files) $(DESTDIR)$(pkgdatadir)/nameToUnicode
	install -d -m 0755 $(DESTDIR)$(pkgdatadir)/unicodeMap
	install -m 0644 $(unicode-map-files) $(DESTDIR)$(pkgdatadir)/unicodeMap

	for f in $(cmap-files); do					    \
		install -d -m 0755 $(DESTDIR)$(pkgdatadir)/`dirname $$f`; \
		install -m 0644 $$f $(DESTDIR)$(pkgdatadir)/$$f;	    \
	done

distdir : $(DISTFILES)
	rm -rf $(distdir)
	mkdir $(distdir)
	for f in $(DISTFILES); do			\
		mkdir -p $(distdir)/$$(dirname $$f);	\
		cp $$f $(distdir)/$$f;			\
	done

dist : distdir
	tar cfz $(distdir).tar.gz $(distdir)
	rm -rf $(distdir)

clean :
	rm -rf $(distdir)

unicode-map-files =				\
	unicodeMap/Big5				\
	unicodeMap/Big5ascii			\
	unicodeMap/EUC-CN			\
	unicodeMap/EUC-JP			\
	unicodeMap/GBK				\
	unicodeMap/ISO-2022-CN			\
	unicodeMap/ISO-2022-JP			\
	unicodeMap/ISO-2022-KR			\
	unicodeMap/ISO-8859-6			\
	unicodeMap/ISO-8859-7			\
	unicodeMap/ISO-8859-8			\
	unicodeMap/ISO-8859-9			\
	unicodeMap/KOI8-R			\
	unicodeMap/Latin2			\
	unicodeMap/Shift-JIS			\
	unicodeMap/TIS-620			\
	unicodeMap/Windows-1255


cmap-files =							\
	cMap/Adobe-CNS1/Adobe-CNS1-0				\
	cMap/Adobe-CNS1/Adobe-CNS1-1				\
	cMap/Adobe-CNS1/Adobe-CNS1-2				\
	cMap/Adobe-CNS1/Adobe-CNS1-3				\
	cMap/Adobe-CNS1/Adobe-CNS1-4				\
	cMap/Adobe-CNS1/Adobe-CNS1-5				\
	cMap/Adobe-CNS1/Adobe-CNS1-6				\
	cMap/Adobe-CNS1/Adobe-CNS1-B5pc				\
	cMap/Adobe-CNS1/Adobe-CNS1-ETen-B5			\
	cMap/Adobe-CNS1/Adobe-CNS1-H-CID			\
	cMap/Adobe-CNS1/Adobe-CNS1-H-Host			\
	cMap/Adobe-CNS1/Adobe-CNS1-H-Mac			\
	cMap/Adobe-CNS1/Adobe-CNS1-UCS2				\
	cMap/Adobe-CNS1/B5-H					\
	cMap/Adobe-CNS1/B5pc-H					\
	cMap/Adobe-CNS1/B5pc-UCS2				\
	cMap/Adobe-CNS1/B5pc-UCS2C				\
	cMap/Adobe-CNS1/B5pc-V					\
	cMap/Adobe-CNS1/B5-V					\
	cMap/Adobe-CNS1/CNS1-H					\
	cMap/Adobe-CNS1/CNS1-V					\
	cMap/Adobe-CNS1/CNS2-H					\
	cMap/Adobe-CNS1/CNS2-V					\
	cMap/Adobe-CNS1/CNS-EUC-H				\
	cMap/Adobe-CNS1/CNS-EUC-V				\
	cMap/Adobe-CNS1/ETen-B5-H				\
	cMap/Adobe-CNS1/ETen-B5-UCS2				\
	cMap/Adobe-CNS1/ETen-B5-V				\
	cMap/Adobe-CNS1/ETenms-B5-H				\
	cMap/Adobe-CNS1/ETenms-B5-V				\
	cMap/Adobe-CNS1/ETHK-B5-H				\
	cMap/Adobe-CNS1/ETHK-B5-V				\
	cMap/Adobe-CNS1/HKdla-B5-H				\
	cMap/Adobe-CNS1/HKdla-B5-V				\
	cMap/Adobe-CNS1/HKdlb-B5-H				\
	cMap/Adobe-CNS1/HKdlb-B5-V				\
	cMap/Adobe-CNS1/HKgccs-B5-H				\
	cMap/Adobe-CNS1/HKgccs-B5-V				\
	cMap/Adobe-CNS1/HKm314-B5-H				\
	cMap/Adobe-CNS1/HKm314-B5-V				\
	cMap/Adobe-CNS1/HKm471-B5-H				\
	cMap/Adobe-CNS1/HKm471-B5-V				\
	cMap/Adobe-CNS1/HKscs-B5-H				\
	cMap/Adobe-CNS1/HKscs-B5-V				\
	cMap/Adobe-CNS1/UCS2-B5pc				\
	cMap/Adobe-CNS1/UCS2-ETen-B5				\
	cMap/Adobe-CNS1/UniCNS-UCS2-H				\
	cMap/Adobe-CNS1/UniCNS-UCS2-V				\
	cMap/Adobe-CNS1/UniCNS-UTF16-H				\
	cMap/Adobe-CNS1/UniCNS-UTF16-V				\
	cMap/Adobe-CNS1/UniCNS-UTF32-H				\
	cMap/Adobe-CNS1/UniCNS-UTF32-V				\
	cMap/Adobe-CNS1/UniCNS-UTF8-H				\
	cMap/Adobe-CNS1/UniCNS-UTF8-V				\
	cMap/Adobe-GB1/Adobe-GB1-0				\
	cMap/Adobe-GB1/Adobe-GB1-1				\
	cMap/Adobe-GB1/Adobe-GB1-2				\
	cMap/Adobe-GB1/Adobe-GB1-3				\
	cMap/Adobe-GB1/Adobe-GB1-4				\
	cMap/Adobe-GB1/Adobe-GB1-5				\
	cMap/Adobe-GB1/Adobe-GB1-GBK-EUC			\
	cMap/Adobe-GB1/Adobe-GB1-GBpc-EUC			\
	cMap/Adobe-GB1/Adobe-GB1-H-CID				\
	cMap/Adobe-GB1/Adobe-GB1-H-Host				\
	cMap/Adobe-GB1/Adobe-GB1-H-Mac				\
	cMap/Adobe-GB1/Adobe-GB1-UCS2				\
	cMap/Adobe-GB1/GB-EUC-H					\
	cMap/Adobe-GB1/GB-EUC-V					\
	cMap/Adobe-GB1/GB-H					\
	cMap/Adobe-GB1/GBK2K-H					\
	cMap/Adobe-GB1/GBK2K-V					\
	cMap/Adobe-GB1/GBK-EUC-H				\
	cMap/Adobe-GB1/GBK-EUC-UCS2				\
	cMap/Adobe-GB1/GBK-EUC-V				\
	cMap/Adobe-GB1/GBKp-EUC-H				\
	cMap/Adobe-GB1/GBKp-EUC-V				\
	cMap/Adobe-GB1/GBpc-EUC-H				\
	cMap/Adobe-GB1/GBpc-EUC-UCS2				\
	cMap/Adobe-GB1/GBpc-EUC-UCS2C				\
	cMap/Adobe-GB1/GBpc-EUC-V				\
	cMap/Adobe-GB1/GBT-EUC-H				\
	cMap/Adobe-GB1/GBT-EUC-V				\
	cMap/Adobe-GB1/GBT-H					\
	cMap/Adobe-GB1/GBTpc-EUC-H				\
	cMap/Adobe-GB1/GBTpc-EUC-V				\
	cMap/Adobe-GB1/GBT-V					\
	cMap/Adobe-GB1/GB-V					\
	cMap/Adobe-GB1/UCS2-GBK-EUC				\
	cMap/Adobe-GB1/UCS2-GBpc-EUC				\
	cMap/Adobe-GB1/UniGB-UCS2-H				\
	cMap/Adobe-GB1/UniGB-UCS2-V				\
	cMap/Adobe-GB1/UniGB-UTF16-H				\
	cMap/Adobe-GB1/UniGB-UTF16-V				\
	cMap/Adobe-GB1/UniGB-UTF32-H				\
	cMap/Adobe-GB1/UniGB-UTF32-V				\
	cMap/Adobe-GB1/UniGB-UTF8-H				\
	cMap/Adobe-GB1/UniGB-UTF8-V				\
	cMap/Adobe-Japan1/78-EUC-H				\
	cMap/Adobe-Japan1/78-EUC-V				\
	cMap/Adobe-Japan1/78-H					\
	cMap/Adobe-Japan1/78ms-RKSJ-H				\
	cMap/Adobe-Japan1/78ms-RKSJ-V				\
	cMap/Adobe-Japan1/78-RKSJ-H				\
	cMap/Adobe-Japan1/78-RKSJ-V				\
	cMap/Adobe-Japan1/78-V					\
	cMap/Adobe-Japan1/83pv-RKSJ-H				\
	cMap/Adobe-Japan1/90msp-RKSJ-H				\
	cMap/Adobe-Japan1/90msp-RKSJ-V				\
	cMap/Adobe-Japan1/90ms-RKSJ-H				\
	cMap/Adobe-Japan1/90ms-RKSJ-UCS2			\
	cMap/Adobe-Japan1/90ms-RKSJ-V				\
	cMap/Adobe-Japan1/90pv-RKSJ-H				\
	cMap/Adobe-Japan1/90pv-RKSJ-UCS2			\
	cMap/Adobe-Japan1/90pv-RKSJ-UCS2C			\
	cMap/Adobe-Japan1/90pv-RKSJ-V				\
	cMap/Adobe-Japan1/Add-H					\
	cMap/Adobe-Japan1/Add-RKSJ-H				\
	cMap/Adobe-Japan1/Add-RKSJ-V				\
	cMap/Adobe-Japan1/Add-V					\
	cMap/Adobe-Japan1/Adobe-Japan1-0			\
	cMap/Adobe-Japan1/Adobe-Japan1-1			\
	cMap/Adobe-Japan1/Adobe-Japan1-2			\
	cMap/Adobe-Japan1/Adobe-Japan1-3			\
	cMap/Adobe-Japan1/Adobe-Japan1-4			\
	cMap/Adobe-Japan1/Adobe-Japan1-5			\
	cMap/Adobe-Japan1/Adobe-Japan1-6			\
	cMap/Adobe-Japan1/Adobe-Japan1-90ms-RKSJ		\
	cMap/Adobe-Japan1/Adobe-Japan1-90pv-RKSJ		\
	cMap/Adobe-Japan1/Adobe-Japan1-H-CID			\
	cMap/Adobe-Japan1/Adobe-Japan1-H-Host			\
	cMap/Adobe-Japan1/Adobe-Japan1-H-Mac			\
	cMap/Adobe-Japan1/Adobe-Japan1-PS-H			\
	cMap/Adobe-Japan1/Adobe-Japan1-PS-V			\
	cMap/Adobe-Japan1/Adobe-Japan1-UCS2			\
	cMap/Adobe-Japan1/EUC-H					\
	cMap/Adobe-Japan1/EUC-V					\
	cMap/Adobe-Japan1/Ext-H					\
	cMap/Adobe-Japan1/Ext-RKSJ-H				\
	cMap/Adobe-Japan1/Ext-RKSJ-V				\
	cMap/Adobe-Japan1/Ext-V					\
	cMap/Adobe-Japan1/H					\
	cMap/Adobe-Japan1/Hankaku				\
	cMap/Adobe-Japan1/Hiragana				\
	cMap/Adobe-Japan1/Hojo-EUC-H				\
	cMap/Adobe-Japan1/Hojo-EUC-V				\
	cMap/Adobe-Japan1/Hojo-H				\
	cMap/Adobe-Japan1/Hojo-V				\
	cMap/Adobe-Japan1/Katakana				\
	cMap/Adobe-Japan1/NWP-H					\
	cMap/Adobe-Japan1/NWP-V					\
	cMap/Adobe-Japan1/RKSJ-H				\
	cMap/Adobe-Japan1/RKSJ-V				\
	cMap/Adobe-Japan1/Roman					\
	cMap/Adobe-Japan1/UCS2-90ms-RKSJ			\
	cMap/Adobe-Japan1/UCS2-90pv-RKSJ			\
	cMap/Adobe-Japan1/UniHojo-UCS2-H			\
	cMap/Adobe-Japan1/UniHojo-UCS2-V			\
	cMap/Adobe-Japan1/UniHojo-UTF16-H			\
	cMap/Adobe-Japan1/UniHojo-UTF16-V			\
	cMap/Adobe-Japan1/UniHojo-UTF32-H			\
	cMap/Adobe-Japan1/UniHojo-UTF32-V			\
	cMap/Adobe-Japan1/UniHojo-UTF8-H			\
	cMap/Adobe-Japan1/UniHojo-UTF8-V			\
	cMap/Adobe-Japan1/UniJIS2004-UTF16-H			\
	cMap/Adobe-Japan1/UniJIS2004-UTF16-V			\
	cMap/Adobe-Japan1/UniJIS2004-UTF32-H			\
	cMap/Adobe-Japan1/UniJIS2004-UTF32-V			\
	cMap/Adobe-Japan1/UniJIS2004-UTF8-H			\
	cMap/Adobe-Japan1/UniJIS2004-UTF8-V			\
	cMap/Adobe-Japan1/UniJISPro-UCS2-HW-V			\
	cMap/Adobe-Japan1/UniJISPro-UCS2-V			\
	cMap/Adobe-Japan1/UniJISPro-UTF8-V			\
	cMap/Adobe-Japan1/UniJIS-UCS2-H				\
	cMap/Adobe-Japan1/UniJIS-UCS2-HW-H			\
	cMap/Adobe-Japan1/UniJIS-UCS2-HW-V			\
	cMap/Adobe-Japan1/UniJIS-UCS2-V				\
	cMap/Adobe-Japan1/UniJIS-UTF16-H			\
	cMap/Adobe-Japan1/UniJIS-UTF16-V			\
	cMap/Adobe-Japan1/UniJIS-UTF32-H			\
	cMap/Adobe-Japan1/UniJIS-UTF32-V			\
	cMap/Adobe-Japan1/UniJIS-UTF8-H				\
	cMap/Adobe-Japan1/UniJIS-UTF8-V				\
	cMap/Adobe-Japan1/UniJISX02132004-UTF32-H		\
	cMap/Adobe-Japan1/UniJISX02132004-UTF32-V		\
	cMap/Adobe-Japan1/UniJISX0213-UTF32-H			\
	cMap/Adobe-Japan1/UniJISX0213-UTF32-V			\
	cMap/Adobe-Japan1/V					\
	cMap/Adobe-Japan1/WP-Symbol				\
	cMap/Adobe-Japan2/Adobe-Japan2-0			\
	cMap/Adobe-Korea1/Adobe-Korea1-0			\
	cMap/Adobe-Korea1/Adobe-Korea1-1			\
	cMap/Adobe-Korea1/Adobe-Korea1-2			\
	cMap/Adobe-Korea1/Adobe-Korea1-H-CID			\
	cMap/Adobe-Korea1/Adobe-Korea1-H-Host			\
	cMap/Adobe-Korea1/Adobe-Korea1-H-Mac			\
	cMap/Adobe-Korea1/Adobe-Korea1-KSCms-UHC		\
	cMap/Adobe-Korea1/Adobe-Korea1-KSCpc-EUC		\
	cMap/Adobe-Korea1/Adobe-Korea1-UCS2			\
	cMap/Adobe-Korea1/KSC-EUC-H				\
	cMap/Adobe-Korea1/KSC-EUC-V				\
	cMap/Adobe-Korea1/KSC-H					\
	cMap/Adobe-Korea1/KSC-Johab-H				\
	cMap/Adobe-Korea1/KSC-Johab-V				\
	cMap/Adobe-Korea1/KSCms-UHC-H				\
	cMap/Adobe-Korea1/KSCms-UHC-HW-H			\
	cMap/Adobe-Korea1/KSCms-UHC-HW-V			\
	cMap/Adobe-Korea1/KSCms-UHC-UCS2			\
	cMap/Adobe-Korea1/KSCms-UHC-V				\
	cMap/Adobe-Korea1/KSCpc-EUC-H				\
	cMap/Adobe-Korea1/KSCpc-EUC-UCS2			\
	cMap/Adobe-Korea1/KSCpc-EUC-UCS2C			\
	cMap/Adobe-Korea1/KSCpc-EUC-V				\
	cMap/Adobe-Korea1/KSC-V					\
	cMap/Adobe-Korea1/UCS2-KSCms-UHC			\
	cMap/Adobe-Korea1/UCS2-KSCpc-EUC			\
	cMap/Adobe-Korea1/UniKS-UCS2-H				\
	cMap/Adobe-Korea1/UniKS-UCS2-V				\
	cMap/Adobe-Korea1/UniKS-UTF16-H				\
	cMap/Adobe-Korea1/UniKS-UTF16-V				\
	cMap/Adobe-Korea1/UniKS-UTF32-H				\
	cMap/Adobe-Korea1/UniKS-UTF32-V				\
	cMap/Adobe-Korea1/UniKS-UTF8-H				\
	cMap/Adobe-Korea1/UniKS-UTF8-V

name-to-unicode-files =				\
	nameToUnicode/Bulgarian			\
	nameToUnicode/Greek			\
	nameToUnicode/Thai

cid-to-unicode-files =				\
	cidToUnicode/Adobe-CNS1			\
	cidToUnicode/Adobe-GB1			\
	cidToUnicode/Adobe-Japan1		\
	cidToUnicode/Adobe-Korea1

DISTFILES =					\
	Makefile				\
	README					\
	COPYING					\
	COPYING.adobe				\
	COPYING.gpl2				\
	CMakeLists.txt				\
	$(unicode-map-files)			\
	$(cmap-files)				\
	$(name-to-unicode-files)		\
	$(cid-to-unicode-files)

=== debian/changelog ===
texstudio (4.8.2) unstable; urgency=low

   * new release

 -- Benito van der Zander <benibela@users.sourceforge.net>  Fri, 07 Jun 2024 19:05:30 +0200

texstudio (4.8.1) unstable; urgency=low

   * new release

 -- Benito van der Zander <benibela@users.sourceforge.net>  Sat, 11 May 2024 18:09:57 +0200

texstudio (4.8.0) unstable; urgency=low

   * new release

 -- Benito van der Zander <benibela@users.sourceforge.net>  Thu, 28 Mar 2024 13:27:35 +0100

texstudio (4.7.4) unstable; urgency=low

   * new release

 -- Benito van der Zander <benibela@users.sourceforge.net>  Fri, 01 Mar 2024 18:33:01 +0100

texstudio (4.7.3) unstable; urgency=low

   * new release

 -- Benito van der Zander <benibela@users.sourceforge.net>  Sun, 24 Dec 2023 17:27:52 +0100

texstudio (4.7.2) unstable; urgency=low

   * new release

 -- Benito van der Zander <benibela@users.sourceforge.net>  Tue, 05 Dec 2023 18:18:02 +0100

texstudio (4.7.1) unstable; urgency=low

   * new release

 -- Benito van der Zander <benibela@users.sourceforge.net>  Sat, 02 Dec 2023 11:29:15 +0100

texstudio (4.7.0) unstable; urgency=low

   * new release

 -- Benito van der Zander <benibela@users.sourceforge.net>  Mon, 25 Sep 2023 19:43:08 +0200

texstudio (4.6.4) unstable; urgency=low

   * new release

 -- Benito van der Zander <benibela@users.sourceforge.net>  Fri, 11 Aug 2023 18:50:09 +0200

texstudio (4.6.3) unstable; urgency=low

   * new release

 -- Benito van der Zander <benibela@users.sourceforge.net>  Sun, 30 Jul 2023 22:22:17 +0200

texstudio (4.6.2) unstable; urgency=low

   * new release

 -- Benito van der Zander <benibela@users.sourceforge.net>  Sun, 30 Jul 2023 10:27:00 +0200

texstudio (4.6.1) unstable; urgency=low

   * new release

 -- Benito van der Zander <benibela@users.sourceforge.net>  Fri, 28 Jul 2023 18:23:42 +0200

texstudio (4.6.0) unstable; urgency=low

   * new release

 -- Benito van der Zander <benibela@users.sourceforge.net>  Sun, 07 May 2023 18:52:42 +0200

texstudio (4.5.3) unstable; urgency=low

   * new release

 -- Benito van der Zander <benibela@users.sourceforge.net>  Sat, 15 Apr 2023 18:28:11 +0200

texstudio (4.5.2) unstable; urgency=low

   * new release

 -- Benito van der Zander <benibela@users.sourceforge.net>  Sat, 04 Feb 2023 15:42:33 +0100

texstudio (4.5.1) unstable; urgency=low

   * new release

 -- Benito van der Zander <benibela@users.sourceforge.net>  Fri, 23 Dec 2022 09:58:02 +0100

texstudio (4.4.2) unstable; urgency=low

   * new release

 -- Benito van der Zander <benibela@users.sourceforge.net>  Sun, 27 Nov 2022 12:25:50 +0100

texstudio (4.4.1) unstable; urgency=low

   * new release

 -- Benito van der Zander <benibela@users.sourceforge.net>  Sat, 19 Nov 2022 09:35:06 +0100

texstudio (4.4.0) unstable; urgency=low

   * new release

 -- Benito van der Zander <benibela@users.sourceforge.net>  Sun, 04 Sep 2022 21:44:12 +0200

texstudio (4.3.2) unstable; urgency=low

   * new release

 -- Benito van der Zander <benibela@users.sourceforge.net>  Fri, 26 Aug 2022 20:10:40 +0200

texstudio (4.3.1) unstable; urgency=low

   * new release

 -- Benito van der Zander <benibela@users.sourceforge.net>  Sun, 07 Aug 2022 20:46:41 +0200

texstudio (4.3.0) unstable; urgency=low

   * new release

 -- Benito van der Zander <benibela@users.sourceforge.net>  Sat, 14 May 2022 11:24:02 +0200

texstudio (4.2.4) unstable; urgency=low

   * new release

 -- Benito van der Zander <benibela@users.sourceforge.net>  Sun, 17 Apr 2022 11:07:46 +0200

texstudio (4.2.3) unstable; urgency=low

   * new release

 -- Benito van der Zander <benibela@users.sourceforge.net>  Sun, 20 Feb 2022 13:43:54 +0100

texstudio (4.2.2) unstable; urgency=low

   * new release

 -- Benito van der Zander <benibela@users.sourceforge.net>  Thu, 27 Jan 2022 20:05:20 +0100

texstudio (4.2.1) unstable; urgency=low

   * new release

 -- Benito van der Zander <benibela@users.sourceforge.net>  Sun, 09 Jan 2022 11:07:37 +0100

texstudio (4.2.0) unstable; urgency=low

   * new release

 -- Benito van der Zander <benibela@users.sourceforge.net>  Mon, 27 Dec 2021 20:25:34 +0100

texstudio (4.1.3) unstable; urgency=low

   * new release

 -- Benito van der Zander <benibela@users.sourceforge.net>  Tue, 07 Dec 2021 21:06:57 +0100

texstudio (4.1.2) unstable; urgency=low

   * new release

 -- Benito van der Zander <benibela@users.sourceforge.net>  Sun, 21 Nov 2021 09:20:20 +0100

texstudio (4.1.1) unstable; urgency=low

   * new release

 -- Benito van der Zander <benibela@users.sourceforge.net>  Sat, 20 Nov 2021 13:30:32 +0100

texstudio (4.0.5) unstable; urgency=low

   * new release

 -- Benito van der Zander <benibela@users.sourceforge.net>  Sat, 06 Nov 2021 18:23:43 +0100

texstudio (4.0.4) unstable; urgency=low

   * new release

 -- Benito van der Zander <benibela@users.sourceforge.net>  Sat, 30 Oct 2021 21:54:58 +0200

texstudio (4.0.3) unstable; urgency=low

   * new release

 -- Benito van der Zander <benibela@users.sourceforge.net>  Fri, 22 Oct 2021 20:34:29 +0200

texstudio (4.0.2) unstable; urgency=low

   * new release

 -- Benito van der Zander <benibela@users.sourceforge.net>  Mon, 11 Oct 2021 21:25:17 +0200

texstudio (4.0.1) unstable; urgency=low

   * new release

 -- Benito van der Zander <benibela@users.sourceforge.net>  Sat, 25 Sep 2021 21:47:59 +0200

texstudio (4.0.0) unstable; urgency=low

   * new release

 -- Benito van der Zander <benibela@users.sourceforge.net>  Fri, 14 May 2021 19:42:34 +0200

texstudio (3.1.2) unstable; urgency=low

   * new release

 -- Benito van der Zander <benibela@users.sourceforge.net>  Mon, 22 Feb 2021 17:32:29 +0100

texstudio (3.1.1) unstable; urgency=low

   * new release

 -- Benito van der Zander <benibela@users.sourceforge.net>  Wed, 17 Feb 2021 19:40:22 +0100

texstudio (3.1.0) unstable; urgency=low

   * new release

 -- Benito van der Zander <benibela@users.sourceforge.net>  Sun, 14 Feb 2021 17:02:20 +0100

texstudio (3.0.5) unstable; urgency=low

   * new release



=== PKGBUILD ===
# Maintainer: Konstantin Podsvirov <konstantin@podsvirov.pro>

_realname=texstudio
pkgbase=mingw-w64-${_realname}
pkgname=("${MINGW_PACKAGE_PREFIX}-${_realname}")
pkgver=4.8.2
pkgrel=1
pkgdesc="Integrated writing environment for creating LaTeX documents (mingw-w64)"
arch=('any')
mingw_arch=('mingw64' 'ucrt64' 'clang64')
url="http://texstudio.sourceforge.net/"
msys2_repository_url='https://github.com/texstudio-org/texstudio'
license=('spdx:GPL-3.0-or-later')
depends=("${MINGW_PACKAGE_PREFIX}-poppler-qt6"
         "${MINGW_PACKAGE_PREFIX}-quazip-qt6"
         "${MINGW_PACKAGE_PREFIX}-hunspell"
         "${MINGW_PACKAGE_PREFIX}-qt6-svg"
         "${MINGW_PACKAGE_PREFIX}-qt6-declarative"
         "${MINGW_PACKAGE_PREFIX}-qt6-5compat")
makedepends=("${MINGW_PACKAGE_PREFIX}-cc"
             "${MINGW_PACKAGE_PREFIX}-cmake"
             "${MINGW_PACKAGE_PREFIX}-ninja"
             "${MINGW_PACKAGE_PREFIX}-pkgconf"
             "${MINGW_PACKAGE_PREFIX}-qt6-tools")
optdepends=("${MINGW_PACKAGE_PREFIX}-evince: pdf reader")
source=("${_realname}-$pkgver.tar.gz::${msys2_repository_url}/archive/${pkgver}.tar.gz"
        '0001-install-extra-files-on-mingw.patch'
        '0002-texstudio-4.2.2-fallbackpaths-win32-as-unix.patch'
        '0003-texstudio-4.2.3-fix-cast-to-smaller-type.patch'
        '0004-texstudio-4.7.3-win32-unicode.patch')
sha256sums=('363a289099911b41caac42d4fa6374794473ff6ed4487c2e4a07a7f59f866a45'
            'b89f798f910e54dc6618edc09ab2834537897b5b18e0590fcb75c3530d4796fb'
            '50695b93a29f9d0078d9a46e281a2366cae36d78d4ebd54e835151041fe7d359'
            'ee2a685c006f21312700ed9ea8fee5d93f22695540375c69ede13d83a2e03407'
            '5ffad3d5047c1d169aad727ed709840d8fc77c1bba49aff7ef89605e783dc00c')

prepare() {
    cd ${srcdir}/${_realname}-${pkgver}

    patch -Np1 -i "${srcdir}"/0001-install-extra-files-on-mingw.patch
    patch -Np1 -i "${srcdir}"/0002-texstudio-4.2.2-fallbackpaths-win32-as-unix.patch
    patch -Np1 -i "${srcdir}"/0003-texstudio-4.2.3-fix-cast-to-smaller-type.patch
    patch -Np1 -i "${srcdir}"/0004-texstudio-4.7.3-win32-unicode.patch
}

build() {
    mkdir -p "${srcdir}/build-${MSYSTEM}" && cd "${srcdir}/build-${MSYSTEM}"

    declare -a _extra_config
    if check_option "debug" "n"; then
        _extra_config+=("-DCMAKE_BUILD_TYPE=Release")
    else
        _extra_config+=("-DCMAKE_BUILD_TYPE=Debug")
    fi

    MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
    ${MINGW_PREFIX}/bin/cmake.exe -Wno-dev \
        -GNinja \
        -DCMAKE_INSTALL_PREFIX=${MINGW_PREFIX} \
        "${_extra_config[@]}" \
        ../${_realname}-${pkgver}

    ${MINGW_PREFIX}/bin/cmake --build .
}

package() {
    cd "${srcdir}/build-${MSYSTEM}"

    DESTDIR="${pkgdir}" ${MINGW_PREFIX}/bin/cmake --install .

    install -Dm644 "${srcdir}/${_realname}-${pkgver}/COPYING" "${pkgdir}${MINGW_PREFIX}/share/licenses/${_realname}/LICENSE"
}
